﻿-- **********************************************************************
-- GnomTEC Gnomcorder Map
-- Version: 7.1.0.12
-- Author: GnomTEC
-- Copyright 2011-2016 by GnomTEC
-- http://www.gnomtec.de/
-- **********************************************************************
-- load localization first.
local L = LibStub("AceLocale-3.0"):GetLocale("GnomTEC_Gnomcorder_Map")

-- ----------------------------------------------------------------------
-- Legacy global variables and constants (will be deleted in future)
-- ----------------------------------------------------------------------

-- Old saved variables
GnomTEC_Gnomcorder_Map_Options = {
	["DisplayedMap"] = "Stormwind",	
}

-- ----------------------------------------------------------------------
-- Addon global Constants (local)
-- ----------------------------------------------------------------------

-- Prefix for addon communication
local CONST_ADDONMESSAGE_PREFIX = "GNOMTEC_MAP"

-- ----------------------------------------------------------------------
-- Addon global variables (local)
-- ----------------------------------------------------------------------

-- Main options menue with general addon information
local optionsMain = {
	name = "GnomTEC Gnomcorder Map",
	type = "group",
	args = {
		descriptionTitle = {
			order = 1,
			type = "description",
			name = "Kartenmodul für GnomTEC Gnomcorder.\n\n",
		},
		descriptionAbout = {
			name = "About",
			type = "group",
			guiInline = true,
			order = 2,
			args = {
				descriptionVersion = {
				order = 1,
				type = "description",			
				name = "|cffffd700".."Version"..": ".._G["GREEN_FONT_COLOR_CODE"]..GetAddOnMetadata("GnomTEC_Gnomcorder_Map", "Version"),
				},
				descriptionAuthor = {
					order = 2,
					type = "description",
					name = "|cffffd700".."Autor"..": ".."|cffff8c00".."GnomTEC",
				},
				descriptionEmail = {
					order = 3,
					type = "description",
					name = "|cffffd700".."Email"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."info@gnomtec.de",
				},
				descriptionWebsite = {
					order = 4,
					type = "description",
					name = "|cffffd700".."Website"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."http://www.gnomtec.de/",
				},
				descriptionLicense = {
					order = 5,
					type = "description",
					name = "|cffffd700".."Copyright"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."(c)2011-2016 by GnomTEC",
				},
			}
		},
		descriptionLogo = {
			order = 5,
			type = "description",
			name = "",
			image = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\GnomTEC-Logo",
			imageCoords = {0.0,1.0,0.0,1.0},
			imageWidth = 512,
			imageHeight = 128,
		},
	}
}

-- maps which are supported by addon
local availableMaps = {
	["Stormwind City"] = {
		text = "Sturmwind",
		notCheckable = 1,
		func = function () GnomTEC_Gnomcorder_Map:SetMap("Stormwind City"); end,	
		map1 = "Interface\\WorldMap\\StormwindCity\\StormwindCity1",
		map2 = "Interface\\WorldMap\\StormwindCity\\StormwindCity2",
		map3 = "Interface\\WorldMap\\StormwindCity\\StormwindCity3",
		map4 = "Interface\\WorldMap\\StormwindCity\\StormwindCity4",
		map5 = "Interface\\WorldMap\\StormwindCity\\StormwindCity5",
		map6 = "Interface\\WorldMap\\StormwindCity\\StormwindCity6",
		map7 = "Interface\\WorldMap\\StormwindCity\\StormwindCity7",
		map8 = "Interface\\WorldMap\\StormwindCity\\StormwindCity8",
		map9 = "Interface\\WorldMap\\StormwindCity\\StormwindCity9",
		map10 = "Interface\\WorldMap\\StormwindCity\\StormwindCity10",
		map11 = "Interface\\WorldMap\\StormwindCity\\StormwindCity11",
		map12 = "Interface\\WorldMap\\StormwindCity\\StormwindCity12"
	},
	["Elwynn Forest"] = {
		text = "Wald von Elwynn",
		notCheckable = 1,
		func = function () GnomTEC_Gnomcorder_Map:SetMap("Elwynn Forest"); end,
		map1 = "Interface\\WorldMap\\Elwynn\\Elwynn1",
		map2 = "Interface\\WorldMap\\Elwynn\\Elwynn2",
		map3 = "Interface\\WorldMap\\Elwynn\\Elwynn3",
		map4 = "Interface\\WorldMap\\Elwynn\\Elwynn4",
		map5 = "Interface\\WorldMap\\Elwynn\\Elwynn5",
		map6 = "Interface\\WorldMap\\Elwynn\\Elwynn6",
		map7 = "Interface\\WorldMap\\Elwynn\\Elwynn7",
		map8 = "Interface\\WorldMap\\Elwynn\\Elwynn8",
		map9 = "Interface\\WorldMap\\Elwynn\\Elwynn9",
		map10 = "Interface\\WorldMap\\Elwynn\\Elwynn10",
		map11 = "Interface\\WorldMap\\Elwynn\\Elwynn11",
		map12 = "Interface\\WorldMap\\Elwynn\\Elwynn12"
	},	
	["Ironforge"] = {
		text = "Eisenschmiede",
		notCheckable = 1,
		func = function () GnomTEC_Gnomcorder_Map:SetMap("Ironforge"); end,
		map1 = "Interface\\WorldMap\\Ironforge\\Ironforge1",
		map2 = "Interface\\WorldMap\\Ironforge\\Ironforge2",
		map3 = "Interface\\WorldMap\\Ironforge\\Ironforge3",
		map4 = "Interface\\WorldMap\\Ironforge\\Ironforge4",
		map5 = "Interface\\WorldMap\\Ironforge\\Ironforge5",
		map6 = "Interface\\WorldMap\\Ironforge\\Ironforge6",
		map7 = "Interface\\WorldMap\\Ironforge\\Ironforge7",
		map8 = "Interface\\WorldMap\\Ironforge\\Ironforge8",
		map9 = "Interface\\WorldMap\\Ironforge\\Ironforge9",
		map10 = "Interface\\WorldMap\\Ironforge\\Ironforge10",
		map11 = "Interface\\WorldMap\\Ironforge\\Ironforge11",
		map12 = "Interface\\WorldMap\\Ironforge\\Ironforge12"
	},	
	["Dun Morogh"] = {
		text = "Dun Morogh",
		notCheckable = 1,
		func = function () GnomTEC_Gnomcorder_Map:SetMap("Dun Morogh"); end,
		map1 = "Interface\\WorldMap\\DunMorogh\\DunMorogh1",
		map2 = "Interface\\WorldMap\\DunMorogh\\DunMorogh2",
		map3 = "Interface\\WorldMap\\DunMorogh\\DunMorogh3",
		map4 = "Interface\\WorldMap\\DunMorogh\\DunMorogh4",
		map5 = "Interface\\WorldMap\\DunMorogh\\DunMorogh5",
		map6 = "Interface\\WorldMap\\DunMorogh\\DunMorogh6",
		map7 = "Interface\\WorldMap\\DunMorogh\\DunMorogh7",
		map8 = "Interface\\WorldMap\\DunMorogh\\DunMorogh8",
		map9 = "Interface\\WorldMap\\DunMorogh\\DunMorogh9",
		map10 = "Interface\\WorldMap\\DunMorogh\\DunMorogh10",
		map11 = "Interface\\WorldMap\\DunMorogh\\DunMorogh11",
		map12 = "Interface\\WorldMap\\DunMorogh\\DunMorogh12"
	},		
}

-- Last time when a timer event was triggerd
local lastTimerEvent = GetTime()

-- Players which are tracked by map modul
local trackedPlayers = {}

-- ----------------------------------------------------------------------
-- Startup initialization
-- ----------------------------------------------------------------------

GnomTEC_Gnomcorder_Map = LibStub("AceAddon-3.0"):NewAddon("GnomTEC_Gnomcorder_Map", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceComm-3.0")
local Tourist = LibStub("LibTourist-3.0") 

LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Gnomcorder Map Main", optionsMain)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Gnomcorder Map Main", "GnomTEC Gnomcorder Map");

-- ----------------------------------------------------------------------
-- Local functions
-- ----------------------------------------------------------------------

-- function which returns also nil for empty strings
local function emptynil( x ) return x ~= "" and x or nil end

-- sends the actual position to all guild members
function GnomTEC_Gnomcorder_Map:SendPosition()
	local player = UnitName("player")
	local posX, posY = GetPlayerMapPosition("player");
	local map = GetMapInfo();
	local zone = nil;
	
	if not map then
		if GetCurrentMapZone() == 0 then
			if GetCurrentMapContinent() == 0 then
				zone = "Azeroth";
			elseif GetCurrentMapContinent() == -1 then
				zone = "Cosmic map";
			end
		end
	else
		zone = Tourist:GetEnglishZoneFromTexture(map);
	end
		
	if (posX ~= 0 and posY ~= 0 and zone) then
		if (zone == "Stormwind") then
			-- Stormwind kennt LibTourist so nicht
			zone = "Stormwind City"
		end
		GnomTEC_Gnomcorder_Map:ShowPosition(player, zone, posX, posY)	
		if IsInGuild() then
			GnomTEC_Gnomcorder_Map:SendCommMessage(CONST_ADDONMESSAGE_PREFIX, zone.."|"..posX.."|"..posY, "GUILD", nil, "BULK")
		end
	end
end

-- function called when mouse enters the player icon on map (attached in GnomTEC_Gnomcorder_Map:ShowPosition())
local function GnomTEC_Gnomcorder_Map_PlayerFrame_OnEnter(self)
	-- show tooltip
	
	local player = string.gsub(self:GetName(),"GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_","");
	if (player) then
		if (trackedPlayers[player]) then
			GameTooltip:SetOwner(self,"ANCHOR_LEFT");
			GameTooltip:ClearLines();
			GameTooltip:AddLine(trackedPlayers[player].name,255,255,0);
			GameTooltip:AddLine(trackedPlayers[player].rankText,0,255,0);

			local key, value
			for key,value in pairs(trackedPlayers) do
				if (player ~= key) and (8 > abs(trackedPlayers[player].x - value.x)) and (8 > abs(trackedPlayers[player].y - value.y)) then
					GameTooltip:AddLine(value.name,255,255,0);
					GameTooltip:AddLine(value.rankText,0,255,0);
				end
			end			
			
			GameTooltip:Show();
		end
	end
end

-- function called when mouse leaves the player icon on map (attached in GnomTEC_Gnomcorder_Map:ShowPosition())
local function GnomTEC_Gnomcorder_Map_PlayerFrame_OnLeave(self)
	-- hide tooltip
	GameTooltip:Hide();
end

-- function to display all actual positions of tracked players on actual map
function GnomTEC_Gnomcorder_Map:ShowPosition(player, zone, posX, posY)
	local x,y = Tourist:TransposeZoneCoordinate(posX, posY, zone, self.db.char.displayedMap)
		
	if (not x) then
		-- falls angezeigt dann entfernen
		if (trackedPlayers[player]) then
			local playerFrame = getglobal("GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_"..player)
			if (playerFrame) then
				playerFrame:Hide()
			end
			trackedPlayers[player] = nil;
		end
	else
		trackedPlayers[player] = {}
		local name, rankIndex, rankText, rankIcon, imDienst
		
		if (GnomTEC_Gnomcorder_StAN) then
			trackedPlayers[player].name, trackedPlayers[player].rankIndex, trackedPlayers[player].rankText, trackedPlayers[player].rankIcon, trackedPlayers[player].imDienst = GnomTEC_Gnomcorder_StAN:GetPlayerInformation(player)
		end
		
		if (not trackedPlayers[player].name) then
			trackedPlayers[player].name = player
			trackedPlayers[player].rankIndex = 0
			trackedPlayers[player].rankText = "<unbekannter Rang>"
			trackedPlayers[player].rankIcon = "Interface\\WorldMap\\WorldMapPlayerIcon"
			trackedPlayers[player].imDienst = true
		elseif (player == UnitName("player")) then
			trackedPlayers[player].rankIcon = "Interface\\WorldMap\\WorldMapPlayerIcon"
			trackedPlayers[player].imDienst = true
		end
		
		-- compute frame offsets
		trackedPlayers[player].x = 1000.0 / 1024.0 * 400.0 * x			-- visible texture / texturesize * framesize * position 
		trackedPlayers[player].y = -(667.0 / 768.0 * 300.0 * y) - 15	-- visible texture / texturesize * framesize * position - offest
		local playerFrame = getglobal("GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_"..player)
		if (not playerFrame) then
			if (not trackedPlayers[player].imDienst) then
				trackedPlayers[player] = nil
			else
				playerFrame = CreateFrame("Frame","GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_"..player,GNOMTEC_GNOMCORDER_MAP_FRAME)
				playerFrame:SetFrameStrata(GNOMTEC_GNOMCORDER_MAP_FRAME:GetFrameStrata());
				playerFrame:SetFrameLevel(GNOMTEC_GNOMCORDER_MAP_FRAME:GetFrameLevel()+21+trackedPlayers[player].rankIndex)
				playerFrame:SetWidth(16); -- Set these to whatever height/width is needed 
				playerFrame:SetHeight(16); -- for your Texture
				playerFrame:EnableMouse(true);
				playerFrame:HookScript("OnEnter",GnomTEC_Gnomcorder_Map_PlayerFrame_OnEnter);
				playerFrame:HookScript("OnLeave",GnomTEC_Gnomcorder_Map_PlayerFrame_OnLeave);		

				local playerTexture = playerFrame:CreateTexture(nil,"OVERLAY");
				playerTexture:SetTexture(trackedPlayers[player].rankIcon);
				playerTexture:SetAllPoints(playerFrame);
				playerFrame.texture = playerTexture;
				playerFrame:SetAlpha(1.0); 
				playerFrame:SetPoint("CENTER",GNOMTEC_GNOMCORDER_MAP_FRAME,"TOPLEFT", trackedPlayers[player].x,trackedPlayers[player].y)
				playerFrame:Show();
			end
		else
			if (not trackedPlayers[player].imDienst) then
				trackedPlayers[player] = nil
				playerFrame:Hide();		
			else
				playerFrame:SetPoint("CENTER",GNOMTEC_GNOMCORDER_MAP_FRAME,"TOPLEFT", trackedPlayers[player].x,trackedPlayers[player].y)
				playerFrame:Show();		
			end
		end	
	end			
end

-- function to set map which should be displayed
function GnomTEC_Gnomcorder_Map:SetMap(map)
	if (not availableMaps[map]) then
		map = "Stormwind City"
	end
	GNOMTEC_GNOMCORDER_MAP_FRAME_SELECTMAP_BUTTON:SetText(availableMaps[map].text)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP1:SetTexture(availableMaps[map].map1)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP2:SetTexture(availableMaps[map].map2)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP3:SetTexture(availableMaps[map].map3)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP4:SetTexture(availableMaps[map].map4)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP5:SetTexture(availableMaps[map].map5)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP6:SetTexture(availableMaps[map].map6)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP7:SetTexture(availableMaps[map].map7)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP8:SetTexture(availableMaps[map].map8)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP9:SetTexture(availableMaps[map].map9)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP10:SetTexture(availableMaps[map].map10)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP11:SetTexture(availableMaps[map].map11)
	GNOMTEC_GNOMCORDER_MAP_FRAME_MAP12:SetTexture(availableMaps[map].map12)
	
	self.db.char.displayedMap = map

	-- Hide all player positions
	local key, value, playerFrame
	for key,value in pairs(trackedPlayers) do
		playerFrame = getglobal("GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_"..key)
		if (playerFrame) then
			playerFrame:Hide();		
		end	
		trackedPlayers[key] = nil
	end
end

-- callback function for timer events 
local function GnomTEC_Gnomcorder_Map_TimerEvent()
	local t = GetTime()
		
	GnomTEC_Gnomcorder_Map:SendPosition()
		
	lastTimerEvent = t
end

-- ----------------------------------------------------------------------
-- Frame event handler and functions
-- ----------------------------------------------------------------------

-- initialize drop down menu
local function GnomTEC_Gnomcorder_Map_SelectMap_InitializeDropDown(level)
	local key, value
	
	for key,value in pairs(availableMaps) do	
		UIDropDownMenu_AddButton(value)
	end

end

-- select map drop down menu OnLoad
function GnomTEC_Gnomcorder_Map:SelectMap_DropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, GnomTEC_Gnomcorder_Map_SelectMap_InitializeDropDown, "MENU")
end

-- select map drop down menu OnClick
function GnomTEC_Gnomcorder_Map:SelectMap_Button_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_MAP_FRAME_SELECTMAP_DROPDOWN, self:GetName(), 0, 0)
end

-- ----------------------------------------------------------------------
-- Hook functions
-- ----------------------------------------------------------------------

-- ----------------------------------------------------------------------
-- Event handler
-- ----------------------------------------------------------------------

-- event handler for updates of the guild rooster
function GnomTEC_Gnomcorder_Map:GUILD_ROSTER_UPDATE(eventName)
	-- Disable map display of afk / dnd / offline and members who are off duty
	-- aditionaly update Data
	local key, value, playerFrame, playerTexture
	local name, rankIndex, rankText, rankIcon, imDienst

	for key,value in pairs(trackedPlayers) do
		playerFrame = getglobal("GNOMTEC_GNOMCORDER_MAP_FRAME_PLAYER_"..key)
		if (playerFrame) then		
			if (GnomTEC_Gnomcorder_StAN) then
				trackedPlayers[key].name, trackedPlayers[key].rankIndex, trackedPlayers[key].rankText, trackedPlayers[key].rankIcon, trackedPlayers[key].imDienst = GnomTEC_Gnomcorder_StAN:GetPlayerInformation(key)
			end
			if (not trackedPlayers[key].name) then
				trackedPlayers[key].name = key
				trackedPlayers[key].imDienst = false
			elseif (key == UnitName("player")) then
				trackedPlayers[key].rankIcon = "Interface\\WorldMap\\WorldMapPlayerIcon"
			end
			playerTexture = playerFrame.texture
			playerTexture:SetAllPoints(playerFrame);
			playerFrame:SetPoint("CENTER",GNOMTEC_GNOMCORDER_MAP_FRAME,"TOPLEFT", trackedPlayers[key].x,trackedPlayers[key].y)	
			if (not trackedPlayers[key].imDienst) and (key ~= UnitName("player")) then
				trackedPlayers[key] = nil
				playerFrame:Hide();
			end
		end	
	end	
end

-- event handler for addon communication messages
function GnomTEC_Gnomcorder_Map:OnCommReceived(prefix, message, distribution, sender)
	if (prefix == CONST_ADDONMESSAGE_PREFIX) then
		local zone, posX, posY	= strsplit("|",message);
		GnomTEC_Gnomcorder_Map:ShowPosition(sender, zone, posX, posY)
	end
end

-- ----------------------------------------------------------------------
-- Addon OnInitialize, OnEnable and OnDisable
-- ----------------------------------------------------------------------

-- function called on initialization of addon
function GnomTEC_Gnomcorder_Map:OnInitialize()
 	-- Code that you want to run when the addon is first loaded goes here.
	self.db = LibStub("AceDB-3.0"):New("GnomTEC_Gnomcorder_MapDB")

  	GnomTEC_Gnomcorder_Map:Print("Willkommen bei GnomTEC_Gnomcorder_Map")
  	  	
end

-- function called on enable of addon
function GnomTEC_Gnomcorder_Map:OnEnable()
    -- Called when the addon is enabled

	GnomTEC_Gnomcorder_Map:Print("GnomTEC_Gnomcorder_Map Enabled")

	-- Initialize options which are propably not valid because they are new added in new versions of addon
	if (not self.db.char.displayedMap) then
		if (not GnomTEC_Gnomcorder_Map_Options["DisplayedMap"]) then
			self.db.char.displayedMap = "Stormwind City"			
		else
			-- get legacy option
			self.db.char.displayedMap = GnomTEC_Gnomcorder_Map_Options["DisplayedMap"]
		end
	end
	
	-- clear legacy options (full clear with later versions)
	-- GnomTEC_Gnomcorder_Map_Options = nil
	GnomTEC_Gnomcorder_Map_Options["DisplayedMap"] = nil
	
	-- set local parameters
	GnomTEC_Gnomcorder_Map:SetMap(self.db.char.displayedMap)
	
	-- initialize hooks and events
	GnomTEC_Gnomcorder_Map:RegisterEvent("GUILD_ROSTER_UPDATE");
	RegisterAddonMessagePrefix(CONST_ADDONMESSAGE_PREFIX);
	GnomTEC_Gnomcorder_Map:RegisterComm(CONST_ADDONMESSAGE_PREFIX)
	
	-- Add module to GnomTEC Gnomcorder
	GnomTEC_Gnomcorder:AddButton("Map", "Karte", L["L_SHOWMAP"], GNOMTEC_GNOMCORDER_MAP_FRAME, "Interface\\ICONS\\INV_Misc_Map08", "Interface\\ICONS\\INV_Misc_Map08", false, nil, GnomTEC_Gnomcorder_Map_TimerEvent)
end

-- function called on disable of addon
function GnomTEC_Gnomcorder_Map:OnDisable()
    -- Called when the addon is disabled
    GnomTEC_Gnomcorder_Map:UnregisterAllEvents();
end

-- ----------------------------------------------------------------------
-- External API
-- ----------------------------------------------------------------------
