﻿-- **********************************************************************
-- GnomTEC Gnomcorder StAN
-- Version: 7.1.0.18
-- Author: GnomTEC
-- Copyright 2011-2016 by GnomTEC
-- http://www.gnomtec.de/
-- **********************************************************************
-- load localization first.
local L = LibStub("AceLocale-3.0"):GetLocale("GnomTEC_Gnomcorder_StAN")

-- ----------------------------------------------------------------------
-- Legacy global variables and constants (will be deleted in future)
-- ----------------------------------------------------------------------

-- Old saved variables
GnomTEC_Gnomcorder_StAN_Options = {
	["iDZ"] = 0,	
	["GiDZ"] = 0,
	["StAN"] = {},
	["Sort"] = "",
}

-- ----------------------------------------------------------------------
-- Addon global Constants (local)
-- ----------------------------------------------------------------------
local CONST_COLOR_IMDIENST = "|cFF00FF00";
local CONST_COLOR_NOTAVAIL = "|cFFFF0000";
local CONST_COLOR_ONLINE = "|cFFFFFF00";
local CONST_COLOR_OFFLINE = "|cFF888888";

local CONST_RANK_SCHEMATA = {
	S01 = {
		Name = "Zweites Wachbataillon",
		Unit = {
			U01 = {
				Name = "Wachmannschaft",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Rekrut", 				Icon ="Interface\\ICONS\\Achievement_PVP_O_01" }, 	-- OR-1	Soldat
					R02 = { Name = "Gefreiter", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_01" }, 	-- OR-2	Gefreiter
					R03 = { Name = "Obergefreiter", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_02" }, 	-- OR-3	Obergefreiter
					R04 = { Name = "Hauptgefreiter", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-3	Hauptgefreiter
					R05 = { Name = "Stabsgefreiter", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-4	Stabsgefreiter
					R06 = { Name = "Oberstabsgefreiter", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
					R10 = { Name = "Unteroffizier", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- OR-5	Unteroffizier
					R11 = { Name = "Fahnenjunker", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- SO	Fahnenjunker
					R12 = { Name = "Stabsunteroffizier", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- OR-5	Stabsunteroffizier
					R13 = { Name = "Feldwebel", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OR-6	Feldwebel
					R14 = { Name = "Fähnrich", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OF-D	Fähnrich
					R15 = { Name = "Oberfeldwebel", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OR-6	Oberfeldwebel
					R16 = { Name = "Oberfähnrich", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OF-D	Oberfähnrich
					R17 = { Name = "Hauptfeldwebel", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-7	Hauptfeldwebel
					R18 = { Name = "Stabsfeldwebel", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-8	Stabsfeldwebel
					R19 = { Name = "Oberstabsfeldwebel", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
					R30 = { Name = "Leutnant", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_07" }, 	-- OF-1	Leutnant
					R31 = { Name = "Oberleutnant", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_08" }, 	-- OF-1	Oberleutnant
					R32 = { Name = "Hauptmann", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_09" }, 	-- OF-2	Hauptmann
					R33 = { Name = "Stabshauptmann", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_09" }, 	-- OF-2	Stabshauptmann
					R34 = { Name = "Major", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_10" }, 	-- OF-3	Major
					R35 = { Name = "Oberstleutnant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_11" }, 	-- OF-4	Oberstleutnant
					R36 = { Name = "Oberst", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_12" }, 	-- OF-5	Oberst
					-- Generalität
					R40 = { Name = "Brigadegeneral", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_13" }, 	-- OF-6	Brigadegeneral
					R41 = { Name = "Generalmajor", 			Icon ="Interface\\ICONS\\Achievement_PVP_A_14" }, 	-- OF-7	Generalmajor
					R42 = { Name = "Generalleutnant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_15" }, 	-- OF-8	Generalleutnant
					R43 = { Name = "General", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_16" }, 	-- OF-9	General
					
				}
			},
			U02 = {
				Name = "Sanitätseinheit",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Sanitätsrekrut", 			Icon ="Interface\\ICONS\\Achievement_PVP_O_01" }, 	-- OR-1	Soldat
					R02 = { Name = "Sanitätsgefreiter", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_01" }, 	-- OR-2	Gefreiter
					R03 = { Name = "Sanitätsobergefreiter", 	Icon ="Interface\\ICONS\\Achievement_PVP_G_02" }, 	-- OR-3	Obergefreiter
					R04 = { Name = "Sanitätshauptgefreiter", 	Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-3	Hauptgefreiter
--					R05 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-4	Stabsgefreiter
--					R06 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
--					R10 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- OR-5	Unteroffizier
--					R11 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- SO	Fahnenjunker
--					R12 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- OR-5	Stabsunteroffizier
--					R13 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OR-6	Feldwebel
--					R14 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OF-D	Fähnrich
--					R15 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OR-6	Oberfeldwebel
--					R16 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OF-D	Oberfähnrich
--					R17 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-7	Hauptfeldwebel
--					R18 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-8	Stabsfeldwebel
--					R19 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
--					R30 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_07" }, 	-- OF-1	Leutnant
--					R31 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_08" }, 	-- OF-1	Oberleutnant
					R32 = { Name = "Stabsarzt", 				Icon ="Interface\\ICONS\\Achievement_PVP_G_09" }, 	-- OF-2	Hauptmann
--					R33 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_09" }, 	-- OF-2	Stabshauptmann
--					R34 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_10" }, 	-- OF-3	Major
--					R35 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_11" }, 	-- OF-4	Oberstleutnant
--					R36 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_12" }, 	-- OF-5	Oberst
					-- Generalität
--					R40 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_13" }, 	-- OF-6	Brigadegeneral
--					R41 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_14" }, 	-- OF-7	Generalmajor
--					R42 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_15" }, 	-- OF-8	Generalleutnant
--					R43 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_16" }, 	-- OF-9	General
				}
			},
			U03 = {
				Name = "Zivilisten",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Zivilist", 					Icon ="Interface\\ICONS\\Achievement_PVP_P_01" }, 	-- OR-1	Soldat
--					R02 = { Name = "---",		 				Icon ="Interface\\ICONS\\Achievement_PVP_P_01" }, 	-- OR-2	Gefreiter
					R03 = { Name = "Hausmeister", 				Icon ="Interface\\ICONS\\Achievement_PVP_P_02" }, 	-- OR-3	Obergefreiter
--					R04 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-3	Hauptgefreiter
--					R05 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-4	Stabsgefreiter
--					R06 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
--					R10 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- OR-5	Unteroffizier
--					R11 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- SO	Fahnenjunker
--					R12 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- OR-5	Stabsunteroffizier
--					R13 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OR-6	Feldwebel
--					R14 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OF-D	Fähnrich
--					R15 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OR-6	Oberfeldwebel
--					R16 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OF-D	Oberfähnrich
--					R17 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-7	Hauptfeldwebel
--					R18 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-8	Stabsfeldwebel
--					R19 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
--					R30 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_07" }, 	-- OF-1	Leutnant
--					R31 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_08" }, 	-- OF-1	Oberleutnant
--					R32 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_09" }, 	-- OF-2	Hauptmann
--					R33 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_09" }, 	-- OF-2	Stabshauptmann
--					R34 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_10" }, 	-- OF-3	Major
--					R35 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_11" }, 	-- OF-4	Oberstleutnant
--					R36 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_12" }, 	-- OF-5	Oberst
					-- Generalität
--					R40 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_13" }, 	-- OF-6	Brigadegeneral
--					R41 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_14" }, 	-- OF-7	Generalmajor
--					R42 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_15" }, 	-- OF-8	Generalleutnant
--					R43 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_16" }, 	-- OF-9	General
				}
			},
		}
	},
	S02 = {
		Name = "Expedition Crestfall",
		Unit = {
			U01 = {
				Name = "Marine Corps",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Private", 				Icon ="Interface\\ICONS\\Achievement_PVP_O_01" }, 	-- OR-1	Soldat
					R02 = { Name = "Private First Class", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_01" }, 	-- OR-2	Gefreiter
					R03 = { Name = "Lance Corporal", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_02" }, 	-- OR-3	Obergefreiter
--					R04 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-3	Hauptgefreiter
--					R05 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-4	Stabsgefreiter
--					R06 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
					R10 = { Name = "Corporal", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- OR-5	Unteroffizier
--					R11 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- SO	Fahnenjunker
					R12 = { Name = "Sergeant", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_04" }, 	-- OR-5	Stabsunteroffizier
					R13 = { Name = "Staff Sergeant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OR-6	Feldwebel
--					R14 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OF-D	Fähnrich
--					R15 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OR-6	Oberfeldwebel
--					R16 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_05" }, 	-- OF-D	Oberfähnrich
					R17 = { Name = "Gunnery Sergeant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-7	Hauptfeldwebel
					R18 = { Name = "Master Sergeant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-8	Stabsfeldwebel
					R19 = { Name = "Sergeant Major", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
					R30 = { Name = "Second Lieutenant", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_07" }, 	-- OF-1	Leutnant
					R31 = { Name = "First Lieutenant", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_08" }, 	-- OF-1	Oberleutnant
					R32 = { Name = "Captain", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_09" }, 	-- OF-2	Hauptmann
					R33 = { Name = "---", 					Icon ="Interface\\ICONS\\Achievement_PVP_A_09" }, 	-- OF-2	Stabshauptmann
					R34 = { Name = "Major", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_10" }, 	-- OF-3	Major
					R35 = { Name = "Lieutenant Colonel", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_11" }, 	-- OF-4	Oberstleutnant
					R36 = { Name = "Colonel", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_12" }, 	-- OF-5	Oberst
					-- Generalität
					R40 = { Name = "Brigadier General", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_13" }, 	-- OF-6	Brigadegeneral
					R41 = { Name = "Major General", 		Icon ="Interface\\ICONS\\Achievement_PVP_A_14" }, 	-- OF-7	Generalmajor
					R42 = { Name = "Lieutenant General", 	Icon ="Interface\\ICONS\\Achievement_PVP_A_15" }, 	-- OF-8	Generalleutnant
					R43 = { Name = "General", 				Icon ="Interface\\ICONS\\Achievement_PVP_A_16" }, 	-- OF-9	General
					
				}
			},
			U02 = {
				Name = "Schiffsbesatzung",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Leichtmatrose", 			Icon ="Interface\\ICONS\\Achievement_PVP_O_01" }, 	-- OR-1	Soldat
					R02 = { Name = "Matrose", 					Icon ="Interface\\ICONS\\Achievement_PVP_G_01" }, 	-- OR-2	Gefreiter
					R03 = { Name = "Kanonier", 					Icon ="Interface\\ICONS\\Achievement_PVP_G_02" }, 	-- OR-3	Obergefreiter
--					R04 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-3	Hauptgefreiter
--					R05 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-4	Stabsgefreiter
--					R06 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
					R10 = { Name = "Maat", 						Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- OR-5	Unteroffizier
					R11 = { Name = "Seekadett", 				Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- SO	Fahnenjunker
					R12 = { Name = "Obermaat", 					Icon ="Interface\\ICONS\\Achievement_PVP_G_04" }, 	-- OR-5	Stabsunteroffizier
					R13 = { Name = "Bootsmann", 				Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OR-6	Feldwebel
					R14 = { Name = "Fähnrich zur See", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OF-D	Fähnrich
					R15 = { Name = "Oberbootsmann", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OR-6	Oberfeldwebel
					R16 = { Name = "Oberfähnrich zur See", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_05" }, 	-- OF-D	Oberfähnrich
					R17 = { Name = "Hauptbootsmann", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-7	Hauptfeldwebel
					R18 = { Name = "Stabsbootsmann", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-8	Stabsfeldwebel
					R19 = { Name = "Oberstabsbootsmann", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
					R30 = { Name = "Leutnant zur See", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_07" }, 	-- OF-1	Leutnant
					R31 = { Name = "Oberleutnant zur See", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_08" }, 	-- OF-1	Oberleutnant
					R32 = { Name = "Kapitänleutnant", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_09" }, 	-- OF-2	Hauptmann
					R33 = { Name = "Stabskapitänleutnant", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_09" }, 	-- OF-2	Stabshauptmann
					R34 = { Name = "Korvettenkapitän", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_10" }, 	-- OF-3	Major
					R35 = { Name = "Fregattenkapitän", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_11" }, 	-- OF-4	Oberstleutnant
					R36 = { Name = "Kapitän zur See", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_12" }, 	-- OF-5	Oberst
					-- Generalität
					R40 = { Name = "Flottillenadmiral", 		Icon ="Interface\\ICONS\\Achievement_PVP_G_13" }, 	-- OF-6	Brigadegeneral
					R41 = { Name = "Konteradmiral", 			Icon ="Interface\\ICONS\\Achievement_PVP_G_14" }, 	-- OF-7	Generalmajor
					R42 = { Name = "Vizeadmiral", 				Icon ="Interface\\ICONS\\Achievement_PVP_G_15" }, 	-- OF-8	Generalleutnant
					R43 = { Name = "Admiral", 					Icon ="Interface\\ICONS\\Achievement_PVP_G_16" }, 	-- OF-9	General
				}
			},
			U03 = {
				Name = "Sonstige/Sonderränge",
				Rank = {
					-- Mannschaftsdienstgrade
					R01 = { Name = "Zivilist", 					Icon ="Interface\\ICONS\\Achievement_PVP_P_01" }, 	-- OR-1	Soldat
--					R02 = { Name = "---",		 				Icon ="Interface\\ICONS\\Achievement_PVP_P_01" }, 	-- OR-2	Gefreiter
--					R03 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_02" }, 	-- OR-3	Obergefreiter
--					R04 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-3	Hauptgefreiter
--					R05 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-4	Stabsgefreiter
--					R06 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_03" }, 	-- OR-4	Oberstabsgefreiter
					-- Unteroffiziersdienstgrade
					R10 = { Name = "Smutje", 					Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- OR-5	Unteroffizier
--					R11 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- SO	Fahnenjunker
--					R12 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_04" }, 	-- OR-5	Stabsunteroffizier
					R13 = { Name = "Proviantmeister", 			Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OR-6	Feldwebel
--					R14 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OF-D	Fähnrich
--					R15 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OR-6	Oberfeldwebel
--					R16 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_05" }, 	-- OF-D	Oberfähnrich
--					R17 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-7	Hauptfeldwebel
--					R18 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-8	Stabsfeldwebel
--					R19 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_06" }, 	-- OR-9	Oberstabsfeldwebel
					-- Offiziersdienstgrade
					R30 = { Name = "Schiffsarzt", 				Icon ="Interface\\ICONS\\Achievement_PVP_P_07" }, 	-- OF-1	Leutnant
--					R31 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_08" }, 	-- OF-1	Oberleutnant
					R32 = { Name = "Schiffskaplan", 			Icon ="Interface\\ICONS\\Achievement_PVP_P_09" }, 	-- OF-2	Hauptmann
--					R33 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_09" }, 	-- OF-2	Stabshauptmann
--					R34 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_10" }, 	-- OF-3	Major
--					R35 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_11" }, 	-- OF-4	Oberstleutnant
--					R36 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_12" }, 	-- OF-5	Oberst
					-- Generalität
--					R40 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_13" }, 	-- OF-6	Brigadegeneral
--					R41 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_14" }, 	-- OF-7	Generalmajor
--					R42 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_15" }, 	-- OF-8	Generalleutnant
--					R43 = { Name = "---", 						Icon ="Interface\\ICONS\\Achievement_PVP_P_16" }, 	-- OF-9	General
				}
			},
		}
	},
}
			
local CONST_RANK_OLD2NEW = {"R01", "R01", "R02", "R03", "R10", "R11", "R13", "R14", "R15", "R17", "R30", "R31", "R32", "R34" };
local CONST_RANK_OLDMAX = 14;
local CONST_RANK_UNKNOWN_ICON = "Interface\\ICONS\\Achievement_PVP_P_01"

local CONST_ADDONMESSAGE_PREFIX = "GNOMTEC_STAN"

-- ----------------------------------------------------------------------
-- Addon global variables (local)
-- ----------------------------------------------------------------------

-- Main options menue with general addon information
local optionsMain = {
	name = "GnomTEC Gnomcorder StAN",
	type = "group",
	args = {
		descriptionTitle = {
			order = 1,
			type = "description",
			name = "StAN-Modul für GnomTEC Gnomcorder.\n\n",
		},
		descriptionAbout = {
			name = "About",
			type = "group",
			guiInline = true,
			order = 2,
			args = {
				descriptionVersion = {
				order = 1,
				type = "description",			
				name = "|cffffd700".."Version"..": ".._G["GREEN_FONT_COLOR_CODE"]..GetAddOnMetadata("GnomTEC_Gnomcorder_StAN", "Version"),
				},
				descriptionAuthor = {
					order = 2,
					type = "description",
					name = "|cffffd700".."Autor"..": ".."|cffff8c00".."GnomTEC",
				},
				descriptionEmail = {
					order = 3,
					type = "description",
					name = "|cffffd700".."Email"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."info@gnomtec.de",
				},
				descriptionWebsite = {
					order = 4,
					type = "description",
					name = "|cffffd700".."Website"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."http://www.gnomtec.de/",
				},
				descriptionLicense = {
					order = 5,
					type = "description",
					name = "|cffffd700".."Copyright"..": ".._G["HIGHLIGHT_FONT_COLOR_CODE"].."(c)2011-2016 by GnomTEC",
				},
			}
		},
		descriptionLogo = {
			order = 5,
			type = "description",
			name = "",
			image = "Interface\\AddOns\\GnomTEC_Gnomcorder\\Textures\\GnomTEC-Logo",
			imageCoords = {0.0,1.0,0.0,1.0},
			imageWidth = 512,
			imageHeight = 128,
		},
	}
}

-- Last time when a timer event was triggerd
local lastTimerEvent = GetTime()
local lastGuildRoster = GetTime()

-- actual position displayed
local stanPosition = 0
local stanSortIndex = {}
local stanSortBy = "name"

-- actual selected rank schema
local acualSchemata = "S01"

-- ----------------------------------------------------------------------
-- Startup initialization
-- ----------------------------------------------------------------------
GnomTEC_Gnomcorder_StAN = LibStub("AceAddon-3.0"):NewAddon("GnomTEC_Gnomcorder_StAN", "AceConsole-3.0", "AceEvent-3.0", "AceHook-3.0", "AceComm-3.0")

LibStub("AceConfig-3.0"):RegisterOptionsTable("GnomTEC Gnomcorder StAN Main", optionsMain)
LibStub("AceConfigDialog-3.0"):AddToBlizOptions("GnomTEC Gnomcorder StAN Main", "GnomTEC Gnomcorder StAN");

-- ----------------------------------------------------------------------
-- Local functions
-- ----------------------------------------------------------------------

-- function which returns also nil for empty strings
local function emptynil( x ) return x ~= "" and x or nil end

local function GnomTEC_Gnomcorder_StAN_TimerEvent()
	local t = GetTime()

	-- update every minute the iDZ and GiDZ
	if ((t-lastTimerEvent) > 60) then
		if (GnomTEC_Gnomcorder_StAN_Options["iDZ"] > 0) then
			GnomTEC_Gnomcorder_StAN_Options["GiDZ"] = GnomTEC_Gnomcorder_StAN_Options["GiDZ"] + t-lastTimerEvent
			GnomTEC_Gnomcorder_StAN_Options["iDZ"] = GnomTEC_Gnomcorder_StAN_Options["iDZ"] + t-lastTimerEvent
		end
		
		GnomTEC_Gnomcorder_StAN:SendIDZ()

		if ((t-lastGuildRoster) > 300) then
			-- Update rooster when there was no update the last 5 minutes , because API will call our callback only on login/logoff of chars	
			GuildRoster();
			lastGuildRoster = t
		end
		
		lastTimerEvent = t
	end
end

local function GnomTEC_Gnomcorder_StAN_ToggleIDZ(checked)
	local t = GetTime()

	if (checked) then
		GnomTEC_Gnomcorder_StAN_Options["iDZ"] = 1
	else
		if (GnomTEC_Gnomcorder_StAN_Options["iDZ"] > 0) then
			GnomTEC_Gnomcorder_StAN_Options["GiDZ"] = GnomTEC_Gnomcorder_StAN_Options["GiDZ"] + t-lastTimerEvent
			GnomTEC_Gnomcorder_StAN_Options["iDZ"] = GnomTEC_Gnomcorder_StAN_Options["iDZ"] + t-lastTimerEvent
		end
		GnomTEC_Gnomcorder_StAN_Options["iDZ"] = 0
	end
	
	GnomTEC_Gnomcorder_StAN:SendIDZ()
	lastTimerEvent = t

	PlaySound("LEVELUP");
	return checked
end

function GnomTEC_Gnomcorder_StAN:RedrawStAN()
	local i, color

	stanPosition = floor(GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_SLIDER:GetValue())

	for i=1, 8, 1 do
		local button = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i);
		local textNAME = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_NAME");
		local textRANK_DNR = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_RANK_DNR");
		local textPOSITION = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_POSITION");
		local textSUBUNIT = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_SUBUNIT");
		local textIDZ = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_IDZ");
		local textGIDZ = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_GIDZ");
		local textSTATUS = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..i.."_TEXT_STATUS");

		if (stanPosition + i > #stanSortIndex) then
			button:Hide();
		else
			stan = GnomTEC_Gnomcorder_StAN_Options["StAN"][stanSortIndex[stanPosition + i]]

        	if (stan.Online==1) then
				if (stan.Status=="") then
					if (stan.iDZ == "--:--") then
						color = CONST_COLOR_ONLINE
						textSTATUS:SetText(color.."Online|r")
   	             	else
						color = CONST_COLOR_IMDIENST
						textSTATUS:SetText(color.."Im Dienst|r")
                	end
           		else
					color = CONST_COLOR_NOTAVAIL
					textSTATUS:SetText(color..stan.Status.."|r")
				end
        	else
				color = CONST_COLOR_OFFLINE
        		textSTATUS:SetText(color.."Offline|r")
        	end


			textNAME:SetText(stan.Name.." "..stan.Lastname.."|r")		
			if (stan.RankIndex) then
					textRANK_DNR:SetText(color..CONST_RANK_SCHEMATA[stan.SchemataIndex].Unit[stan.UnitIndex].Rank[stan.RankIndex].Name.." / "..stan.DNr.."|r")		
					textSUBUNIT:SetText(color..CONST_RANK_SCHEMATA[stan.SchemataIndex].Unit[stan.UnitIndex].Name.."|r")		
			else
				textRANK_DNR:SetText(color.."--- / ---|r")
				textSUBUNIT:SetText(color.."---".."|r")		
			end
			textPOSITION:SetText(stan.Zone.."|r")		
			textIDZ:SetText(stan.iDZ.."|r")		
			textGIDZ:SetText(stan.GiDZ.."|r")		
			button:Show();
		end
	end
end

-- Compare function for sorting of StAN by name
local function SortStAN_CompareName(a,b)
	return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Name < GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Name;
end
		
-- Compare function for sorting of StAN by rank
local function SortStAN_CompareRank(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].RankIndex == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].RankIndex) then
		return SortStAN_CompareName(a,b)
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].RankIndex > GnomTEC_Gnomcorder_StAN_Options["StAN"][b].RankIndex;
	end
end

-- Compare function for sorting of StAN by name DNr
local function SortStAN_CompareDNr(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].DNr == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].DNr) then
		return SortStAN_CompareName(a,b)
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].DNr < GnomTEC_Gnomcorder_StAN_Options["StAN"][b].DNr;
	end
end

-- Compare function for sorting of StAN by iDZ
local function SortStAN_CompareiDZ(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].iDZ == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].iDZ) then
		return SortStAN_CompareName(a,b)
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].iDZ > GnomTEC_Gnomcorder_StAN_Options["StAN"][b].iDZ;
	end
end

-- Compare function for sorting of StAN by GiDZ
local function SortStAN_CompareGiDZ(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].GiDZ == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].GiDZ) then
		return SortStAN_CompareName(a,b)
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].GiDZ > GnomTEC_Gnomcorder_StAN_Options["StAN"][b].GiDZ;
	end
end

-- Compare function for sorting of StAN by online state
local function SortStAN_CompareOnline(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Online == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Online) then
		if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Status == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Status) then
			return SortStAN_CompareName(a,b)
		else
			return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Status > GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Status;	
		end
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Online > GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Online;
	end
end

-- Compare function for sorting of StAN by zone
local function SortStAN_CompareZone(a,b)
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Position_Zone == GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Position_Zone) then
		return SortStAN_CompareName(a,b)
	else
		return GnomTEC_Gnomcorder_StAN_Options["StAN"][a].Position_Zone < GnomTEC_Gnomcorder_StAN_Options["StAN"][b].Position_Zone;
	end
end


--- Function:    GnomTEC_Gnomcorder_StAN:CreateSortIndex(sort)
--- Parameters:  sort
---						"name"
---						"rank"
---						"dnr"
---						"idz"
---						"gidz"
---						"online"
---						"zone"
--- Comment:     sorting of StAN
function GnomTEC_Gnomcorder_StAN:CreateSortIndex(sort)
	local key, stan
	
	stanSortIndex = {}
		
	count = 0
	for key,stan in pairs(GnomTEC_Gnomcorder_StAN_Options["StAN"]) do
		count = count + 1
		stanSortIndex[count] = key
	end
	
	if not sort then
		sort = stanSortBy;
	else
		stanSortBy = sort;
	end

	if (sort=="rank") then
		table.sort(stanSortIndex,SortStAN_CompareRank);
	elseif (sort=="dnr") then
		table.sort(stanSortIndex,SortStAN_CompareDNr);
	elseif (sort=="idz") then
		table.sort(stanSortIndex,SortStAN_CompareiDZ);
	elseif (sort=="gidz") then
		table.sort(stanSortIndex,SortStAN_CompareGiDZ);
	elseif (sort=="online") then
		table.sort(stanSortIndex,SortStAN_CompareOnline);
	elseif (sort=="zone") then
		table.sort(stanSortIndex,SortStAN_CompareZone);
	else -- name
		table.sort(stanSortIndex,SortStAN_CompareName);
	end
	
end

function GnomTEC_Gnomcorder_StAN:UpdateStAN()
    local total = GetNumGuildMembers(true);
  
	-- invalidate all members
	local key, stan
	for key,stan in pairs(GnomTEC_Gnomcorder_StAN_Options["StAN"]) do
			stan.Valid = false
	end

	-- generate new list
	local i
    for i=1,total do
    	local schemataIndex, unitIndex, dnr
        local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		-- Zone ist manchmal nicht gültig, z.B. wenn char gerade eingeloggt hat
		if (zone == nil) then
			zone = "Unbekannt";
		end
	
		-- 4.3.2 return numbers instead text for status (AFK/DND) with GetGuildRosterInfo() -> added code to reflect this
		if (0 == status) then
			status = ""
		elseif (1 == status) then
			status = "AFK"
		elseif (2 == status) then
			status = "DND"
		else
			status = "Unbekannt"		
		end

		-- 4.3.2 return nil instead 0 for online when player is offline with GetGuildRosterInfo() -> added code to reflect this
		if (not online) then
			online = 0
		end
		
		-- compute military rank from officernote
		rank = tonumber(string.sub(officernote,1,2));
        if (rank == nil) then
  			-- actual rank system			
        	schemataIndex = nil
        	unitIndex = nil
    		rankIndex = nil
    		dnr = "----"
    		
    		if (("S" == string.sub(officernote,1,1)) and ("U" == string.sub(officernote,4,4)) and ("R" == string.sub(officernote,7,7)) and ("D" == string.sub(officernote,10,10))) then
    			schemataIndex = tonumber(string.sub(officernote,2,3))
    			unitIndex = tonumber(string.sub(officernote,5,6))
    			rankIndex = tonumber(string.sub(officernote,8,9))
    			dnr = tonumber(string.sub(officernote,11,14))
    			
    			if (not dnr) then
    				dnr = "----"
    			else
    				dnr = string.format("%04d",dnr)
    			end
    			
    			if ((not schemataIndex) or (not unitIndex) or (not rankIndex)) then
    				-- a invalid field in officer note
    			    schemataIndex = nil
        			unitIndex = nil
    				rankIndex = nil
    			else
    				schemataIndex = "S"..string.format("%02d",schemataIndex)
    				unitIndex = "U"..string.format("%02d",unitIndex)
    				rankIndex = "R"..string.format("%02d",rankIndex)
    				
    				if (not CONST_RANK_SCHEMATA[schemataIndex]) then
    					-- not existing schemata
    				  	schemataIndex = nil
        				unitIndex = nil
    					rankIndex = nil
    				elseif (not CONST_RANK_SCHEMATA[schemataIndex].Unit[unitIndex]) then
    					-- not existing unit
    				  	schemataIndex = nil
        				unitIndex = nil
    					rankIndex = nil
    				elseif (not CONST_RANK_SCHEMATA[schemataIndex].Unit[unitIndex].Rank[rankIndex]) then
    					-- not existing rank
    				    schemataIndex = nil
        				unitIndex = nil
    					rankIndex = nil    			
    				end
    			end
    		end
  		else
  			-- legacy rank system
        	if (rank > CONST_RANK_OLDMAX) then
        		schemataIndex = nil
        		unitIndex = nil
        		rankIndex = nil
        		dnr = "----"
        	else
				-- compute DNr and if San from officernote
				local issan
				dnr = tonumber(string.sub(officernote,4,7));
				if (dnr == nil) then
					dnr = "----"
					issan = false;
				else
					if (dnr > 1000) then
						issan = true;			
					else
						issan = false;
					end
					dnr = string.format("%04d",dnr)
				end
					
				schemataIndex = "S01"
				if (rank == 0) then
					unitIndex = "U03"
					rankIndex = "R01"
				elseif (issan) then
					unitIndex = "U02"
					rankIndex = CONST_RANK_OLD2NEW[rank]
				else
					unitIndex = "U01"
					rankIndex = CONST_RANK_OLD2NEW[rank]					
				end
			end
		end
		
		-- create new entry if not existing and copy data
		if (not GnomTEC_Gnomcorder_StAN_Options["StAN"][name]) then
			GnomTEC_Gnomcorder_StAN_Options["StAN"][name] = {}
			stan = GnomTEC_Gnomcorder_StAN_Options["StAN"][name]
			stan.iDZ = "--:--"
			stan.GiDZ = "----:--"
			stan.Position_X = 0
			stan.Position_Y = 0
			stan.Position_Zone = ""
		else
			stan = GnomTEC_Gnomcorder_StAN_Options["StAN"][name]	
		end

		stan.Valid = true
		-- 5.2.0 name is now fully qualified
		stan.Name = strsplit( "-", name, 2 )		
		stan.Lastname = note
		stan.SchemataIndex = schemataIndex		
		stan.UnitIndex = unitIndex
		stan.RankIndex = rankIndex
		stan.Zone = zone
		stan.Online = online
		stan.Status = status
		stan.DNr = dnr
	end
	
	-- cleanup not existing members
	for key,stan in pairs(GnomTEC_Gnomcorder_StAN_Options["StAN"]) do
		if (not stan.Valid) then
			GnomTEC_Gnomcorder_StAN_Options["StAN"][key] = nil
		end
	end

	if (total > 8) then
		GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_SLIDER:SetMinMaxValues(0,total-8);
	else
		GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_SLIDER:SetMinMaxValues(0,0);		
	end
	
	if (stanPosition > total-8) then
		stanPosition = 0
	end
	GnomTEC_Gnomcorder_StAN:CreateSortIndex(stanSortBy)
	GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_SLIDER:SetValue(stanPosition);
	GnomTEC_Gnomcorder_StAN:RedrawStAN();
end

function GnomTEC_Gnomcorder_StAN:SendIDZ()
	local idz_sekunden,idz_minuten,idz_stunden;
	local gidz_sekunden,gidz_minuten,gidz_stunden;
	local gidz_string, idz_string

	gidz_sekunden = GnomTEC_Gnomcorder_StAN_Options["GiDZ"] % 60;
	gidz_minuten = ((GnomTEC_Gnomcorder_StAN_Options["GiDZ"] - gidz_sekunden) / 60) % 60;
	gidz_stunden = ((((GnomTEC_Gnomcorder_StAN_Options["GiDZ"] - gidz_sekunden) / 60) - gidz_minuten) / 60);
	gidz_string = string.format("%04d:%02d",gidz_stunden,gidz_minuten)
	
	if (GnomTEC_Gnomcorder_StAN_Options["iDZ"] > 0) then
		idz_sekunden = GnomTEC_Gnomcorder_StAN_Options["iDZ"] % 60;
		idz_minuten = ((GnomTEC_Gnomcorder_StAN_Options["iDZ"] - idz_sekunden) / 60) % 60;
		idz_stunden = ((((GnomTEC_Gnomcorder_StAN_Options["iDZ"] - idz_sekunden) / 60) - idz_minuten) / 60);
		idz_string = string.format("%02d:%02d",idz_stunden,idz_minuten)
	else
		idz_string = "--:--"
	end

	local player, realm = UnitName("player")
	realm = string.gsub(realm or GetRealmName(), "%s+", "")
	
	if (GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm]) then
		GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm].iDZ = idz_string
		GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm].GiDZ = gidz_string
		GnomTEC_Gnomcorder_StAN:RedrawStAN()
	end
	
	GnomTEC_Gnomcorder_StAN:SendCommMessage(CONST_ADDONMESSAGE_PREFIX, idz_string.." "..gidz_string, "GUILD", nil, "NORMAL")
end

function GnomTEC_Gnomcorder_StAN:SetOfficerNote(player, officernote)
    local total = GetNumGuildMembers(true);
  	local i
  	
	for i=1,total do
        local name = GetGuildRosterInfo(i);
		if (name == player) then
			GuildRosterSetOfficerNote(i, officernote)
			i = total
		end
	end
end

-- ----------------------------------------------------------------------
-- Frame event handler and functions
-- ----------------------------------------------------------------------

function GnomTEC_Gnomcorder_StAN_Sort_InitializeDropDown(level)
	local info = {}

	function info.func(self, arg1, arg2, checked)
		GnomTEC_Gnomcorder_StAN:CreateSortIndex(arg1)
		GnomTEC_Gnomcorder_StAN:RedrawStAN()
		GNOMTEC_GNOMCORDER_STAN_FRAME_SORT_BUTTON:SetText(arg2)
	end	
	info.notCheckable = true


	info.text = "Sortieren nach Namen"
	info.arg1 = "name"
	info.arg2 = "Sortiert nach Namen"
	UIDropDownMenu_AddButton(info)
	
	info.text = "Sortieren nach Dienstrang"
	info.arg1 = "rank"
	info.arg2 = "Sortiert nach Dienstrang"
	UIDropDownMenu_AddButton(info)
	
	info.text = "Sortieren nach Dienstnummer"
	info.arg1 = "dnr"
	info.arg2 = "Sortiert nach Dienstnummer"
	UIDropDownMenu_AddButton(info)
	
	info.text = "Sortieren nach aktueller Dienstzeit"
	info.arg1 = "idz"
	info.arg2 = "Sortiert nach aktueller Dienstzeit"
	UIDropDownMenu_AddButton(info)
	
	info.text = "Sortieren nach gesamter Dienstzeit"
	info.arg1 = "gidz"
	info.arg2 = "Sortiert nach gesamter Dienstzeit"
	UIDropDownMenu_AddButton(info)

	info.text = "Sortieren nach Onlinestatus"
	info.arg1 = "online"
	info.arg2 = "Sortiert nach Onlinestatus"
	UIDropDownMenu_AddButton(info)
	
	info.text = "Sortieren nach Standort"
	info.arg1 = "zone"
	info.arg2 = "Sortiert nach Standort"
	UIDropDownMenu_AddButton(info)
end

function GnomTEC_Gnomcorder_StAN:Sort_DropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, GnomTEC_Gnomcorder_StAN_Sort_InitializeDropDown, "MENU")
end

function GnomTEC_Gnomcorder_StAN:Sort_Button_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, GNOMTEC_GNOMCORDER_STAN_FRAME_SORT_DROPDOWN, self:GetName(), 0, 0)
end

function GnomTEC_Gnomcorder_StAN:ClickedStAN(id)
	if (stanPosition + id <= #stanSortIndex) then
		-- StAN clicked		
		local stan = GnomTEC_Gnomcorder_StAN_Options["StAN"][stanSortIndex[stanPosition + id]]
		local button = getglobal("GNOMTEC_GNOMCORDER_STAN_FRAME_LIST_STAN"..id);
		local canNotEdit = not CanEditOfficerNote()
		
		local menuUnit = {}
		local menuM, menuU, menuO, menuG, menuR, menuS
		local u,r,s, uStr, rStr, sStr
		local isCheckedUnit, isCheckedGroup, isCheckedRank, isCheckedSchemata
		
	
		if (CONST_RANK_SCHEMATA[acualSchemata]) then
			for u=1, 9, 1 do
				uStr = "U0"..u
				if (CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr]) then
				
					isCheckedUnit = false
					menuR = {}
				
					isCheckedGroup = false
					menuM = nil
					for r=1, 9, 1 do
						rStr = "R"..string.format("%02d",r)
						if (CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr]) then
							if (not menuM) then
								menuM = {}
							end
							isCheckedRank = (rStr == stan.RankIndex) and (uStr == stan.UnitIndex)
							if (isCheckedRank) then
								isCheckedUnit = true
								isCheckedGroup = true
							end
							table.insert(menuM, { text = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Name, icon = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Icon, arg1 = stan.Name, arg2 = acualSchemata..uStr..rStr.."D"..stan.DNr, checked = isCheckedRank, disabled = canNotEdit, func = function(self, arg1, arg2, checked) GnomTEC_Gnomcorder_StAN:SetOfficerNote(arg1, arg2); end })
						end
					end
					if (menuM) then
						table.insert(menuR, { text = "Mannschaftsränge", checked = isCheckedGroup, hasArrow = true, menuList = menuM  })
					end

					isCheckedGroup = false
					menuU = nil
					for r=10, 19, 1 do
						rStr = "R"..string.format("%02d",r)
						if (CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr]) then
							if (not menuU) then
								menuU = {}
							end
							isCheckedRank = (rStr == stan.RankIndex) and (uStr == stan.UnitIndex)
							if (isCheckedRank) then
								isCheckedUnit = true
								isCheckedGroup = true
							end
							table.insert(menuU, { text = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Name, icon = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Icon, arg1 = stan.Name, arg2 = acualSchemata..uStr..rStr.."D"..stan.DNr, checked = isCheckedRank, disabled = canNotEdit, func = function(self, arg1, arg2, checked) GnomTEC_Gnomcorder_StAN:SetOfficerNote(arg1, arg2); end })
						end
					end
					if (menuU) then
						table.insert(menuR, { text = "Unteroffiziersränge", checked = isCheckedGroup, hasArrow = true, menuList = menuU  })
					end

					isCheckedGroup = false
					menuO = nil
					for r=30, 39, 1 do
						rStr = "R"..string.format("%02d",r)
						if (CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr]) then
							if (not menuO) then
								menuO = {}
							end
							isCheckedRank = (rStr == stan.RankIndex) and (uStr == stan.UnitIndex)
							if (isCheckedRank) then
								isCheckedUnit = true
								isCheckedGroup = true
							end
							table.insert(menuO, { text = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Name, icon = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Icon, arg1 = stan.Name, arg2 = acualSchemata..uStr..rStr.."D"..stan.DNr, checked = isCheckedRank, disabled = canNotEdit, func = function(self, arg1, arg2, checked) GnomTEC_Gnomcorder_StAN:SetOfficerNote(arg1, arg2); end })
						end
					end
					if (menuO) then
						table.insert(menuR, { text = "Offiziersränge", checked = isCheckedGroup, hasArrow = true, menuList = menuO  })
					end


					isCheckedGroup = false
					menuG = nil
					for r=40, 49, 1 do
						rStr = "R"..string.format("%02d",r)
						if (CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr]) then
							if (not menuG) then
								menuG = {}
							end
							isCheckedRank = (rStr == stan.RankIndex) and (uStr == stan.UnitIndex)
							if (isCheckedRank) then
								isCheckedUnit = true
								isCheckedGroup = true
							end
							table.insert(menuG, { text = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Name, icon = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Rank[rStr].Icon, arg1 = stan.Name, arg2 = acualSchemata..uStr..rStr.."D"..stan.DNr, checked = isCheckedRank, disabled = canNotEdit, func = function(self, arg1, arg2, checked) GnomTEC_Gnomcorder_StAN:SetOfficerNote(arg1, arg2); end })
						end
					end
					if (menuG) then
						table.insert(menuR, { text = "Generalsränge", checked = isCheckedGroup, hasArrow = true, menuList = menuG  })
					end
					
					table.insert(menuUnit, { text = CONST_RANK_SCHEMATA[acualSchemata].Unit[uStr].Name, checked = isCheckedUnit, hasArrow = true, menuList = menuR })

				end
			end
		end
		
		menuS = {}
		for s=1, 9, 1 do
			sStr = "S0"..s
			if (CONST_RANK_SCHEMATA[sStr]) then
				isCheckedSchemata = (sStr == acualSchemata)
				table.insert(menuS, { text = CONST_RANK_SCHEMATA[sStr].Name, arg1 = sStr, checked = isCheckedSchemata, disabled = canNotEdit, func = function(self, arg1, arg2, checked) acualSchemata = arg1; end })
			end
		end
		
		
		local menu = {
			{ text = stan.Name.." "..stan.Lastname, notCheckable = true, isTitle = true},
			{ text = "Dienstgrad einstellen", hasArrow = true, notCheckable = true, menuList = menuUnit },
			{ text = "Dienstnummer einstellen...", func = function() print("Dienstnummer"); end, notCheckable = true, disabled = true },
			{ text = "Gildeneinstellungen", notCheckable = true, isTitle = true},
			{ text = "Dienstgradschemata", notCheckable = true, hasArrow = true, menuList = menuS }			
		}
		local menuFrame = CreateFrame("Frame", "GNOMTEC_GNOMCORDER_STAN_FRAME_CONTEXTMENU", UIparent, "UIDropDownMenuTemplate")

		-- Make the menu appear at the cursor: 
		--EasyMenu(menu, menuFrame, "cursor", 0 , 0, "MENU");
		-- Or make the menu appear at the frame:
		menuFrame:SetPoint("TOPLEFT", button, "BOTTOMLEFT")
		EasyMenu(menu, menuFrame, button, 0 , 0, "MENU");
	end
end

-- ----------------------------------------------------------------------
-- Hook functions
-- ----------------------------------------------------------------------

-- ----------------------------------------------------------------------
-- Event handler
-- ----------------------------------------------------------------------
function GnomTEC_Gnomcorder_StAN:OnCommReceived(prefix, message, distribution, sender)
	if (prefix == CONST_ADDONMESSAGE_PREFIX) then
		local player, realm = strsplit( "-", sender, 2 )
		realm = string.gsub(realm or GetRealmName(), "%s+", "")

		if (GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm]) then
			 GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm].iDZ, GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm].GiDZ = strsplit(" ",message);
			 GnomTEC_Gnomcorder_StAN:RedrawStAN()
		end
	end
end

function GnomTEC_Gnomcorder_StAN:GUILD_ROSTER_UPDATE(eventName)
	lastGuildRoster = GetTime()
	GnomTEC_Gnomcorder_StAN:UpdateStAN()
end

-- ----------------------------------------------------------------------
-- Addon OnInitialize, OnEnable and OnDisable
-- ----------------------------------------------------------------------

-- function called on initialization of addon
function GnomTEC_Gnomcorder_StAN:OnInitialize()
 	-- Code that you want to run when the addon is first loaded goes here.
  
  	GnomTEC_Gnomcorder_StAN:Print("Willkommen bei GnomTEC_Gnomcorder_StAN")
end

-- function called on enable of addon
function GnomTEC_Gnomcorder_StAN:OnEnable()
    -- Called when the addon is enabled

	GnomTEC_Gnomcorder_StAN:Print("GnomTEC_Gnomcorder_StAN Enabled")

	-- Initialize options which are propably not valid because they are new added in new versions of addon
	
	-- set local parameters
	GuildRoster();
	GnomTEC_Gnomcorder_StAN:UpdateStAN()
	
	-- initialize hooks and events
	GnomTEC_Gnomcorder_StAN:RegisterEvent("GUILD_ROSTER_UPDATE");
	RegisterAddonMessagePrefix(CONST_ADDONMESSAGE_PREFIX);
	GnomTEC_Gnomcorder_StAN:RegisterComm(CONST_ADDONMESSAGE_PREFIX)

	
	-- Add module to GnomTEC Gnomcorder
	GnomTEC_Gnomcorder:AddButton("StAN", "StAN", "StAN anzeigen", GNOMTEC_GNOMCORDER_STAN_FRAME, "Interface\\ICONS\\INV_Misc_Book_12", "Interface\\ICONS\\INV_Misc_Book_12", false, nil, GnomTEC_Gnomcorder_StAN_TimerEvent)
	GnomTEC_Gnomcorder:AddButton("StAN", "Dienst", "Dienst antreten/beenden", nil, "Interface\\ICONS\\Achievement_PVP_O_A", "Interface\\ICONS\\Achievement_PVP_A_A", (GnomTEC_Gnomcorder_StAN_Options["iDZ"] > 0), GnomTEC_Gnomcorder_StAN_ToggleIDZ)
end

-- function called on disable of addon
function GnomTEC_Gnomcorder_StAN:OnDisable()
    -- Called when the addon is disabled
    GnomTEC_Gnomcorder_StAN:UnregisterAllEvents();
end

-- ----------------------------------------------------------------------
-- External API
-- ----------------------------------------------------------------------

function GnomTEC_Gnomcorder_StAN:GetPlayerInformation(playerName)
	local player, realm = strsplit( "-", playerName, 2 )
	realm = string.gsub(realm or GetRealmName(), "%s+", "")

	local stan = GnomTEC_Gnomcorder_StAN_Options["StAN"][player.."-"..realm]
	if (not stan ) then
		return nil
	else
		local name = stan.Name.." "..stan.Lastname
		local rankIndex = stan.RankIndex
		local rankText = ""
		local rankIcon =""
		local imDienst = false
				
		if (stan.RankIndex) then
				rankText = CONST_RANK_SCHEMATA[stan.SchemataIndex].Unit[stan.UnitIndex].Rank[stan.RankIndex].Name
				rankIcon = CONST_RANK_SCHEMATA[stan.SchemataIndex].Unit[stan.UnitIndex].Rank[stan.RankIndex].Icon
		else
			rankIndex = "R01"
			rankText = "---"
			rankIcon = CONST_RANK_UNKNOWN_ICON
		end
		
       	if (stan.Online==1) then
       		if (stan.iDZ == "--:--") then
				imDienst = false
   	       	else
				imDienst = true
           	end
       	else
			imDienst = false
       	end
       	
       	return name, tonumber(string.sub(rankIndex,2,3)), rankText, rankIcon, imDienst
	end
end



